<?php
/*======================================================================*\
|| #################################################################### ||
|| # vBulletin-Entertain Version 1.0.0                                # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2007-2011, AddOn-Coders (http://www.addon-coders.de)  # ||
|| # ---------------------------------------------------------------- # ||
|| # Dateiname/filename: vbentertain.php                            # ||
|| # ---------------------------------------------------------------- # ||
|| # Support nur unter http://www.vbulletin-germany.org               # ||
|| # ---------------------------------------------------------------- # ||
|| # Dieses ist keine freie Software! nderungen, unerlaubtes Nutzen  # ||
|| # oder unerlaubte Verbreitung sind nicht erlaubt (auch nicht in    # ||
|| # Auszgen oder Einzelteilen) - This is not free software, changes # ||
|| # in and unallowed use of (parts from) this script is not allowed! # ||
|| #################################################################### ||
\*======================================================================*/

// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);
@set_time_limit(0);

// #################### PRE-CACHE TEMPLATES AND DATA ######################
$phrasegroups = array(
	'forum',
	'cpuser',
	'forumdisplay',
	'prefix',
	'vbentertain',
	'maintenance',
);

$globaltemplates = array('vbentertain');
$specialtemplates = array('vbentertain');

// get special data templates from the datastore
$specialtemplates = array(
	'vbentertain',
);

$actiontemplates = array();

// ########################## REQUIRE BACK-END ############################
require_once('./global.php');
require_once(DIR . '/includes/adminfunctions_template.php');
require_once(DIR . '/includes/functions_misc.php');
require_once(DIR . '/includes/adminfunctions_vbentertain.php');

// ######################## CHECK ADMIN PERMISSIONS #######################
if (!can_administer('canentertain'))
{
	print_cp_no_permission();
}

// ############################# LOG ACTION ###############################
log_admin_action();

// ########################################################################
// ######################### START MAIN SCRIPT ############################
// ########################################################################
if (in_array($_REQUEST['do'], array('managecats', 'doordercats', 'addcat', 'editcat', 'updatecat', 'removecat', 'killcat')))
{
	print_cp_header($vbphrase['vbentertain_adminheadline_cats']);
}
else if (in_array($_REQUEST['do'], array('manageitems')))
{
	print_cp_header($vbphrase['vbentertain_adminheadline_items']);
}
else if (in_array($_REQUEST['do'], array('tools')))
{
	print_cp_header($vbphrase['vbentertain_adminheadline_tools']);
}
else if (in_array($_REQUEST['do'], array('info')))
{
	print_cp_header($vbphrase['vbentertain_adminheadline_info']);
}
else
{
	print_cp_header($vbphrase['vbentertain_adminheadline']);
}

if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'managecats';
}

// ########################################################################
// edit or add category
if ($_REQUEST['do'] == 'addcat' OR $_REQUEST['do'] == 'editcat')
{
	$vbulletin->input->clean_array_gpc('r', array(
		'catid'	 	 => TYPE_UINT,
		'parentid'	 => TYPE_UINT
	));

	if ($_REQUEST['do'] == 'addcat')
	{
		if (!($vbulletin->GPC['parentid'] == ''))
		{
			$cat['parentid'] = $vbulletin->GPC['parentid'];
		}

		$cat['defaulticon'] = '1';
		$cat['status'] = '1';
		$cat['displayorder'] = '1';
		$cat['groupshow'] = '1';

		$cat['allowhtml'] = '0';
		$cat['allowbbcode'] = '1';
		$cat['allowsmilies'] = '1';

		$cat['sell_opt'] = '1';
		$cat['search_opt'] = '1';
		$cat['change_opt'] = '0';
		$cat['free_opt'] = '0';

		$cat['subtitle_active'] = '1';

		$newcat = true;

		print_form_header('vbentertain', 'updatecat');
		print_table_header($vbphrase['vbentertain_add_new_category']);
		construct_hidden_code('catid', '0');
	}
	else
	{
		$newcat = false;

		require_once(DIR . '/includes/functions_vbentertain.php');
		if (!($cat = fetch_entertain_catinfo($vbulletin->GPC['catid'])))
		{
			print_stop_message('vbentertain_invalid_cat_specified');
		}

		// fetch usergroups
		$membersarray = array('membergroupids' => $cat['groupshowlist']);

		print_form_header('vbentertain', 'updatecat');
		print_table_header(construct_phrase($vbphrase['vbentertain_cat_x_y_id_z'], $vbphrase['vbentertain_category'], $cat['name'], $cat['id']));
		construct_hidden_code('catid', $vbulletin->GPC['catid']);
	}

	$cat['name'] = str_replace('&amp;', '&', $cat['name']);
	$cat['description'] = str_replace('&amp;', '&', $cat['description']);

	print_input_row($vbphrase['vbentertain_category_name'], 'cat[name]', $cat['name']);
	print_textarea_row($vbphrase['vbentertain_description'], 'cat[description]', $cat['description']);
	print_yes_no_row($vbphrase['vbentertain_cat_is_active'], 'cat[status]', $cat['status']);
	print_input_row($vbphrase['vbentertain_displayorder'], 'cat[displayorder]', $cat['displayorder']);

	$parentcats = array(
		'-1' => $vbphrase['none']
	);

	if ($vbulletin->vbentertain['categories'])
	{
		foreach ($vbulletin->vbentertain['categories'] AS $catid => $currentcat)
		{
			if ($catid == $cat['id'])
			{
				continue;
			}

			$parentcats["$catid"] = $currentcat['name'];
		}
	}

	print_select_row($vbphrase['vbentertain_parent_cat'], 'cat[parentid]', $parentcats, $cat['parentid']);

	print_yes_no_row($vbphrase['vbentertain_cat_groupshow'], 'cat[groupshow]', $cat['groupshow']);
	print_membergroup_row($vbphrase['vbentertain_cat_groupshow_list'], 'cat[groupshowlist]', 2, $membersarray);

	print_table_header($vbphrase['enable_disable_features']);
	print_yes_no_row($vbphrase['allow_html'], 'cat[allowhtml]', $cat['allowhtml']);
	print_yes_no_row($vbphrase['allow_bbcode'], 'cat[allowbbcode]', $cat['allowbbcode']);
	print_yes_no_row($vbphrase['allow_smilies'], 'cat[allowsmilies]', $cat['allowsmilies']);
	print_submit_row($vbphrase['vbentertain_save_cat']);
}

// ########################################################################
// update category
if ($_POST['do'] == 'updatecat')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'catid'			=> TYPE_UINT,
		'cat'			=> TYPE_ARRAY
	));

	require_once(DIR . '/includes/functions_vbentertain.php');
	$cat = fetch_entertain_catinfo($vbulletin->GPC['catid']);

	if ($vbulletin->GPC['cat']['name'] == '')
	{
		define('CP_REDIRECT', 'vbentertain.php?do=managecats');
		print_stop_message('vbentertain_saved_category_not_successfull');
	}

	$usergrouparray =& htmlspecialchars_uni($vbulletin->GPC['cat']['groupshowlist']);

	if ($usergrouparray)
	{
		$usergrouparray = implode(',', $usergrouparray);
	}
	else
	{
		$usergrouparray = '';
	}

	$parentid = intval($vbulletin->GPC['cat']['parentid']);
	$parentcat = fetch_entertain_catinfo($parentid);

	if (!$parentcat)
	{
		$parentid = -1;
	}

	if (!$cat)
	{
		$db->query_write("INSERT INTO " . TABLE_PREFIX . "vbentertain_category (name, description, status, parentid, displayorder, groupshow, groupshowlist, allowhtml, allowbbcode, allowsmilies)
		VALUES (
			'" . $db->escape_string($vbulletin->GPC['cat']['name']) . "',
			'" . $db->escape_string($vbulletin->GPC['cat']['description']) . "',
			'" . intval($vbulletin->GPC['cat']['status']) . "',
			'" . $parentid . "',
			'" . intval($vbulletin->GPC['cat']['displayorder']) . "',
			'" . intval($vbulletin->GPC['cat']['groupshow']) . "',
			'" . $db->escape_string($usergrouparray) . "',
			'" . intval($vbulletin->GPC['cat']['allowhtml']) . "',
			'" . intval($vbulletin->GPC['cat']['allowbbcode']) . "',
			'" . intval($vbulletin->GPC['cat']['allowsmilies']) . "'
		)");
	}
	else
	{
		$db->query_write("UPDATE " . TABLE_PREFIX . "vbentertain_category SET
			name = '" . $db->escape_string($vbulletin->GPC['cat']['name']) . "',
			description = '" . $db->escape_string($vbulletin->GPC['cat']['description']) . "',
			status = '" . intval($vbulletin->GPC['cat']['status']) . "',
			parentid = '" . $parentid . "',
			displayorder = '" . intval($vbulletin->GPC['cat']['displayorder']) . "',
			groupshow = '" . intval($vbulletin->GPC['cat']['groupshow']) . "',
			groupshowlist = '" . $db->escape_string($usergrouparray) . "',
			allowhtml = '" . intval($vbulletin->GPC['cat']['allowhtml']) . "',
			allowbbcode = '" . intval($vbulletin->GPC['cat']['allowbbcode']) . "',
			allowsmilies = '" . intval($vbulletin->GPC['cat']['allowsmilies']) . "'
			WHERE id = '" . intval($cat['id']) . "'
		");
	}

	// actualize datastore
	build_vbentertain_datastore(true);

	define('CP_REDIRECT', 'vbentertain.php?do=managecats');
	print_stop_message('vbentertain_saved_category_x_successfully', $vbulletin->GPC['cat']['name']);
}

// ########################################################################
// order catetories
if ($_POST['do'] == 'doordercats')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'order' => TYPE_ARRAY
	));

	if (is_array($vbulletin->GPC['order']))
	{
		$cats = $db->query_read("
			SELECT *
			FROM " . TABLE_PREFIX . "vbentertain_category
		");

		while ($cat = $db->fetch_array($cats))
		{
			if (!isset($vbulletin->GPC['order']["$cat[id]"]))
			{
				continue;
			}

			$displayorder = intval($vbulletin->GPC['order']["$cat[id]"]);
			if ($cat['displayorder'] != $displayorder)
			{
				$db->query_write("
					UPDATE " . TABLE_PREFIX . "vbentertain_category
					SET displayorder = '" . intval($displayorder) . "'
					WHERE id = '" . intval($cat['id']) . "'
				");
			}
		}
	}

	// actualize datastore
	build_vbentertain_datastore(true);

	define('CP_REDIRECT', 'vbentertain.php?do=managecats');
	print_stop_message('vbentertain_saved_displayorder_successfully');
}

// ########################################################################
// remove cat
if ($_REQUEST['do'] == 'removecat')
{
	$vbulletin->input->clean_array_gpc('r', array(
		'catid' => TYPE_UINT
	));

	$cat = $db->query_first("
		SELECT *
		FROM " . TABLE_PREFIX . "vbentertain_category
		WHERE id = " . intval($vbulletin->GPC['catid']) . "
	");

	print_form_header('vbentertain', 'killcat');
	print_table_header(construct_phrase($vbphrase['vbentertain_delete_cat_x_y_id_z'], $vbphrase['vbentertain_category'], $cat['name'], $cat['id']));
	construct_hidden_code('catid', $vbulletin->GPC['catid']);

	print_yes_no_row($vbphrase['vbentertain_delete_category'], 'cat[delete]', 0);
	print_yes_no_row($vbphrase['vbentertain_move_items'], 'cat[moveitems]', 0);

	// make array for all categories to prune into select row
	$prunecats = $db->query_read("
		SELECT *
		FROM " . TABLE_PREFIX . "vbentertain_category
	");

	$pruneoptions = array();

	while ($prunecat = $db->fetch_array($prunecats))
	{
		if (!($prunecat['id'] == $vbulletin->GPC['catid']))
		{
			$pruneoptions[$prunecat['id']] = $prunecat['name'];
		}
	}
	print_select_row($vbphrase['vbentertain_move_items_choose'], 'cat[moveitemsto]', $pruneoptions, $cat['parentid']);

	print_yes_no_row($vbphrase['vbentertain_move_subcats'], 'cat[movesubcats]', 0);
	while ($prunecat = $db->fetch_array($prunecats))
	{
		$pruneoptions[$prunecat['id']] = $prunecat['name'];
	}
	print_select_row($vbphrase['vbentertain_move_subcats_choose'], 'cat[movesubcatsto]', $pruneoptions, $cat['parentid']);

	print_submit_row($vbphrase['vbentertain_kill_cat']);
}

// ########################################################################
// remove cat
if ($_REQUEST['do'] == 'killcat')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'catid' => TYPE_UINT,
		'cat'	=> TYPE_ARRAY
	));

	if ($vbulletin->GPC['cat']['delete'] == 1)
	{
		if ($vbulletin->GPC['cat']['moveitems'] == 1)
		{
			$db->query_write("
				UPDATE " . TABLE_PREFIX . "vbentertain_item
				SET categoryid = '" . intval($vbulletin->GPC['cat']['moveitemsto']) . "'
				WHERE categoryid = '" . intval($vbulletin->GPC['catid']) . "'
			");
		}

		if ($vbulletin->GPC['cat']['movesubcats'] == 1)
		{
			$db->query_write("
				UPDATE " . TABLE_PREFIX . "vbentertain_category
				SET parentid = '" . intval($vbulletin->GPC['cat']['movesubcatsto']) . "'
				WHERE parentid = '" . intval($vbulletin->GPC['catid']) . "'
			");
		}

		$db->query_write("DELETE FROM " . TABLE_PREFIX . "vbentertain_category WHERE id = '" . intval($vbulletin->GPC['catid']) . "'");

		// actualize datastore
		build_vbentertain_datastore(true);

		define('CP_REDIRECT', 'vbentertain.php?do=managecats');
		print_stop_message('vbentertain_deleted_category_successfully');
	}
	else
	{
		define('CP_REDIRECT', 'vbentertain.php?do=managecats');
		print_stop_message('vbentertain_deleted_category_error');
	}
}

// ########################################################################
// manage categories
if ($_REQUEST['do'] == 'managecats')
{
	$categoryoptions = array(
		'dummy'		=> $vbphrase['vbentertain_choose_cat_option'],
		'editcat'	=> $vbphrase['vbentertain_edit_category'],
		'removecat'	=> $vbphrase['vbentertain_delete_category'],
		'addcat'	=> $vbphrase['vbentertain_add_child_category'],
	);

	// a little javascript for the options menus
	?>
	<script type="text/javascript">
	<!--
	function js_forum_jump(foruminfo)
	{
		if (foruminfo == 0)
		{
			alert('<?php echo addslashes_js($vbphrase['vbentertain_please_select_cat']); ?>');
			return;
		}
		else if (typeof(document.cpform.forumid) != 'undefined')
		{
			action = document.cpform.controls.options[document.cpform.controls.selectedIndex].value;
		}
		else
		{
			action = eval("document.cpform.f" + foruminfo + ".options[document.cpform.f" + foruminfo + ".selectedIndex].value");
		}
		if (action != '')
		{
			switch (action)
			{
				case 'editcat':		page = "vbentertain.php?do=editcat&catid=";
							break;
				case 'removecat':	page = "vbentertain.php?do=removecat&catid=";
							break;
				case 'addcat':		page = "vbentertain.php?do=addcat&parentid=";
							break;
			}
			document.cpform.reset();
			jumptopage = page + foruminfo + "&s=<?php echo $vbulletin->session->vars['sessionhash']; ?>";

			window.location = jumptopage;

		}
		else
		{
			alert('<?php echo addslashes_js($vbphrase['vbentertain_invalid_action_specified']); ?>');
		}
	}
	//-->
	</script>
	<?php

	print_form_header('vbentertain', 'doordercats');

	print_table_header($vbphrase['vbentertain_category_manager'], 3);
	print_description_row($vbphrase['vbentertain_if_you_change_displayorder'], 0, 3);

	// main depth
	$entertaincats = $db->query_read("
		SELECT *
		FROM " . TABLE_PREFIX . "vbentertain_category
		WHERE parentid < 0
		ORDER BY displayorder ASC
	");

	print_cells_row(array($vbphrase['vbentertain_category'], $vbphrase['vbentertain_cat_setting'], $vbphrase['vbentertain_cat_displayorder']), 1, 'tcat');

	while ($cat = $db->fetch_array($entertaincats))
	{
		$cell = array();

		$cell[] = "<a name=\"cat$cat[id]\">&nbsp;</a><b><a href=\"vbentertain.php?" . $vbulletin->session->vars['sessionurl'] . "do=editcat&amp;catid=$cat[id]\">$cat[name]</a></b>";
		$cell[] = "\n\t<select name=\"f$cat[id]\" onchange=\"js_forum_jump($cat[id]);\" class=\"bginput\">\n" . construct_select_options($categoryoptions) . "\t</select><input type=\"button\" class=\"button\" value=\"" . $vbphrase['go'] . "\"  />\n\t";
		$cell[] = "<input type=\"text\" class=\"bginput\" name=\"order[$cat[id]]\" value=\"$cat[displayorder]\" tabindex=\"1\" size=\"3\" title=\"\" />";

		print_cells_row($cell);

		// depth 1
		$entertainsubcats = $db->query_read("
			SELECT *
			FROM " . TABLE_PREFIX . "vbentertain_category
			WHERE parentid = " . $cat['id'] . "
			ORDER BY displayorder ASC
		");

		while ($cat = $db->fetch_array($entertainsubcats))
		{
			$cell = array();

			$cell[] = "<a name=\"cat$cat[id]\">&nbsp;</a><b>- - <a href=\"vbentertain.php?" . $vbulletin->session->vars['sessionurl'] . "do=editcat&amp;catid=$cat[id]\">$cat[name]</a></b>";
			$cell[] = "\n\t<select name=\"f$cat[id]\" onchange=\"js_forum_jump($cat[id]);\" class=\"bginput\">\n" . construct_select_options($categoryoptions) . "\t</select><input type=\"button\" class=\"button\" value=\"" . $vbphrase['go'] . "\"  />\n\t";
			$cell[] = "<input type=\"text\" class=\"bginput\" name=\"order[$cat[id]]\" value=\"$cat[displayorder]\" tabindex=\"1\" size=\"3\" title=\"\" />";

			print_cells_row($cell);

			// depth 2
			$entertainsubcats2 = $db->query_read("
				SELECT *
				FROM " . TABLE_PREFIX . "vbentertain_category
				WHERE parentid = " . $cat['id'] . "
				ORDER BY displayorder ASC
			");

			while ($cat = $db->fetch_array($entertainsubcats2))
			{
				$cell = array();

				$cell[] = "<a name=\"cat$cat[id]\">&nbsp;</a><b>- - - - <a href=\"vbentertain.php?" . $vbulletin->session->vars['sessionurl'] . "do=editcat&amp;catid=$cat[id]\">$cat[name]</a></b>";
				$cell[] = "\n\t<select name=\"f$cat[id]\" onchange=\"js_forum_jump($cat[id]);\" class=\"bginput\">\n" . construct_select_options($categoryoptions) . "\t</select><input type=\"button\" class=\"button\" value=\"" . $vbphrase['go'] . "\"  />\n\t";
				$cell[] = "<input type=\"text\" class=\"bginput\" name=\"order[$cat[id]]\" value=\"$cat[displayorder]\" tabindex=\"1\" size=\"3\" title=\"\" />";

				print_cells_row($cell);

				// depth 3
				$entertainsubcats3 = $db->query_read("
					SELECT *
					FROM " . TABLE_PREFIX . "vbentertain_category
					WHERE parentid = " . $cat['id'] . "
					ORDER BY displayorder ASC
				");

				while ($cat = $db->fetch_array($entertainsubcats3))
				{
					$cell = array();

					$cell[] = "<a name=\"cat$cat[id]\">&nbsp;</a><b>- - - - - - <a href=\"vbentertain.php?" . $vbulletin->session->vars['sessionurl'] . "do=editcat&amp;catid=$cat[id]\">$cat[name]</a></b>";
					$cell[] = "\n\t<select name=\"f$cat[id]\" onchange=\"js_forum_jump($cat[id]);\" class=\"bginput\">\n" . construct_select_options($categoryoptions) . "\t</select><input type=\"button\" class=\"button\" value=\"" . $vbphrase['go'] . "\"  />\n\t";
					$cell[] = "<input type=\"text\" class=\"bginput\" name=\"order[$cat[id]]\" value=\"$cat[displayorder]\" tabindex=\"1\" size=\"3\" title=\"\" />";

					print_cells_row($cell);

					// depth 4
					$entertainsubcats4 = $db->query_read("
						SELECT *
						FROM " . TABLE_PREFIX . "vbentertain_category
						WHERE parentid = " . $cat['id'] . "
						ORDER BY displayorder ASC
					");

					while ($cat = $db->fetch_array($entertainsubcats4))
					{
						$cell = array();
			
						$cell[] = "<a name=\"cat$cat[id]\">&nbsp;</a><b>- - - - - - - - <a href=\"vbentertain.php?" . $vbulletin->session->vars['sessionurl'] . "do=editcat&amp;catid=$cat[id]\">$cat[name]</a></b>";
						$cell[] = "\n\t<select name=\"f$cat[id]\" onchange=\"js_forum_jump($cat[id]);\" class=\"bginput\">\n" . construct_select_options($categoryoptions) . "\t</select><input type=\"button\" class=\"button\" value=\"" . $vbphrase['go'] . "\"  />\n\t";
						$cell[] = "<input type=\"text\" class=\"bginput\" name=\"order[$cat[id]]\" value=\"$cat[displayorder]\" tabindex=\"1\" size=\"3\" title=\"\" />";

						print_cells_row($cell);

						// depth 5
						$entertainsubcats5 = $db->query_read("
							SELECT *
							FROM " . TABLE_PREFIX . "vbentertain_category
							WHERE parentid = " . $cat['id'] . "
							ORDER BY displayorder ASC
						");

						while ($cat = $db->fetch_array($entertainsubcats5))
						{
							$cell = array();

							$cell[] = "<a name=\"cat$cat[id]\">&nbsp;</a><b>- - - - - - - - - - <a href=\"vbentertain.php?" . $vbulletin->session->vars['sessionurl'] . "do=editcat&amp;catid=$cat[id]\">$cat[name]</a></b>";
							$cell[] = "\n\t<select name=\"f$cat[id]\" onchange=\"js_forum_jump($cat[id]);\" class=\"bginput\">\n" . construct_select_options($categoryoptions) . "\t</select><input type=\"button\" class=\"button\" value=\"" . $vbphrase['go'] . "\"  />\n\t";
							$cell[] = "<input type=\"text\" class=\"bginput\" name=\"order[$cat[id]]\" value=\"$cat[displayorder]\" tabindex=\"1\" size=\"3\" title=\"\" />";

							print_cells_row($cell);

							// depth 6
							$entertainsubcats6 = $db->query_read("
								SELECT *
								FROM " . TABLE_PREFIX . "vbentertain_category
								WHERE parentid = " . $cat['id'] . "
								ORDER BY displayorder ASC
							");

							while ($cat = $db->fetch_array($entertainsubcats6))
							{
								$cell = array();

								$cell[] = "<a name=\"cat$cat[id]\">&nbsp;</a><b>- - - - - - - - - - - - <a href=\"vbentertain.php?" . $vbulletin->session->vars['sessionurl'] . "do=editcat&amp;catid=$cat[id]\">$cat[name]</a></b>";
								$cell[] = "\n\t<select name=\"f$cat[id]\" onchange=\"js_forum_jump($cat[id]);\" class=\"bginput\">\n" . construct_select_options($categoryoptions) . "\t</select><input type=\"button\" class=\"button\" value=\"" . $vbphrase['go'] . "\"  />\n\t";
								$cell[] = "<input type=\"text\" class=\"bginput\" name=\"order[$cat[id]]\" value=\"$cat[displayorder]\" tabindex=\"1\" size=\"3\" title=\"\" />";

								print_cells_row($cell);
							}
						}
					}
				}
			}
		}
	}

	print_table_footer(3, "<input type=\"submit\" class=\"button\" tabindex=\"1\" value=\"" . $vbphrase['vbentertain_cat_save_displayorder'] . "\" accesskey=\"s\" />" . construct_button_code($vbphrase['vbentertain_add_new_category'], "vbentertain.php?" . $vbulletin->session->vars['sessionurl'] . "do=addcat"));
}

// ########################################################################
// tools
if ($_REQUEST['do'] == 'tools')
{
	// re-create datastore
	$cell = array();
	$cell[] = $vbphrase['vbentertain_tools_description'];
	$cell[] = $vbphrase['vbentertain_tools_possible_function'];
	$cells = sizeof($cell);

	echo '<br /><table cellpadding="4" cellspacing="0" border="0" align="center" width="90%" class="tborder" id="cpform_table2">';
	print_table_header($vbphrase['vbentertain_tools_create_datastore'], $cells);
	print_description_row($vbphrase['vbentertain_tools_create_datastore_desc'], 0, $cells);
	print_cells_row($cell, 1);

	$cell = array();
	$cell[] = $vbphrase['vbentertain_tools_create_datastore_desc_2'];
	$cell[] = "<div align=\"center\"><form action=\"vbentertain.php?do=generatedatastore\" method=\"post\" name=\"cpformgenerateds\" id=\"cpformgenerateds\"><input type=\"hidden\" name=\"securitytoken\" value=\"" . $vbulletin->userinfo['securitytoken'] . "\"><input type=\"hidden\" name=\"generateds\" value=\"tools\"><input type=\"submit\" class=\"button\" name=\"generateds\" value=\"$vbphrase[vbentertain_tools_create_datastore_button]\"></small></form>";
	print_cells_row($cell);
	echo '</table>';
	print_table_footer();

	// check for changed usernames
	$cell = array();
	$cell[] = $vbphrase['vbentertain_tools_description'];
	$cell[] = $vbphrase['vbentertain_tools_possible_function'];
	$cells = sizeof($cell);

	echo '<br /><table cellpadding="4" cellspacing="0" border="0" align="center" width="90%" class="tborder" id="cpform_table">';
	print_table_header($vbphrase['vbentertain_tools_aliascheck'], $cells);
	print_description_row($vbphrase['vbentertain_tools_aliascheck_desc'], 0, $cells);
	print_cells_row($cell, 1);

	$cell = array();
	$cell[] = $vbphrase['vbentertain_tools_aliascheck_desc_2'];
	$cell[] = "<div align=\"center\"><form action=\"vbentertain.php?do=aliascheck\" method=\"post\" name=\"cpformaliascheck\" id=\"cpformaliascheck\"><input type=\"hidden\" name=\"securitytoken\" value=\"" . $vbulletin->userinfo['securitytoken'] . "\"><input type=\"hidden\" name=\"aliascheck\" value=\"aliascheck\"><input type=\"submit\" class=\"button\" name=\"filealiascheck\" value=\"$vbphrase[vbentertain_tools_aliascheck_button]\"></small></form>";
	print_cells_row($cell);
	echo '</table>';
	print_table_footer();
}

// ########################################################################
// generate statistic
if ($_REQUEST['do'] == 'generatedatastore')
{
	build_vbentertain_datastore(true);

	define('CP_REDIRECT', 'vbentertain.php?do=tools');
	print_stop_message('vbentertain_datastore_generated_successfully');
}

// ########################################################################
// check aliases for changes
if ($_REQUEST['do'] == 'aliascheck')
{
	$db->query_write("UPDATE " . TABLE_PREFIX . "vbentertain_item AS vbentertain, " . TABLE_PREFIX . "user AS user SET vbentertain.username=user.username WHERE vbentertain.userid=user.userid");

	define('CP_REDIRECT', 'vbentertain.php?do=tools');
	print_stop_message('vbentertain_alias_check_successfully');
}

// ########################################################################
// manage items
if ($_REQUEST['do'] == 'manageitems')
{
	global $Installarray;
	$Installarray = '';

	// ---------- import items
	$parentcats = array(
		'-1' => $vbphrase['none']
	);

	if ($vbulletin->vbentertain['categories'])
	{
		foreach ($vbulletin->vbentertain['categories'] AS $catid => $currentcat)
		{
			if ($catid == $cat['id'])
			{
				continue;
			}

			$parentcats["$catid"] = $currentcat['name'];
		}
	}

	print_form_header('vbentertain', 'importitems', 1, 1, 'importform');
	print_table_header($vbphrase['vbentertain_items_user_import']);
	print_description_row($vbphrase['vbentertain_items_user_import_desc']);
	print_upload_row($vbphrase['vbentertain_items_import_filename'], 'xmlfile', 999999999);
	print_select_row($vbphrase['vbentertain_items_import_category'], 'catid', $parentcats, $cat['parentid']);
	print_submit_row($vbphrase['vbentertain_items_import_button'], 0);

	// ---------- export items
	$parentcats = array(
		'-1' => $vbphrase['all']
	);

	if ($vbulletin->vbentertain['categories'])
	{
		foreach ($vbulletin->vbentertain['categories'] AS $catid => $currentcat)
		{
			if ($catid == $cat['id'])
			{
				continue;
			}

			$parentcats["$catid"] = $currentcat['name'];
		}
	}

	print_form_header('vbentertain', 'exportitems', 1, 1, 'exportform');
	print_table_header($vbphrase['vbentertain_items_user_export']);
	print_description_row($vbphrase['vbentertain_items_user_export_desc']);
	print_select_row($vbphrase['vbentertain_items_export_category'], 'catid', $parentcats, $cat['parentid']);
	print_submit_row($vbphrase['vbentertain_items_user_export_button'], 0);

	// ---------- delete items
	$parentcats = array(
		'-1' => $vbphrase['all']
	);

	if ($vbulletin->vbentertain['categories'])
	{
		foreach ($vbulletin->vbentertain['categories'] AS $catid => $currentcat)
		{
			if ($catid == $cat['id'])
			{
				continue;
			}

			$parentcats["$catid"] = $currentcat['name'];
		}
	}

	print_form_header('vbentertain', 'deleteitems', 1, 1, 'deleteform');
	print_table_header($vbphrase['vbentertain_items_user_delete']);
	print_description_row($vbphrase['vbentertain_items_user_delete_desc']);
	print_select_row($vbphrase['vbentertain_items_delete_category'], 'catid', $parentcats, $cat['parentid']);
	print_submit_row($vbphrase['vbentertain_items_user_delete_button'], 0);

	print_table_footer();
}

// ########################################################################
// choose items for export items and start the action to generate the .sql-file
if ($_REQUEST['do'] == 'exportitems')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'catid' 	=> TYPE_UINT,
	));

	if ($vbulletin->GPC['catid'] == '0')
	{
		$where = '';
	} 
	else
	{
		$where = "WHERE categoryid = '" . intval($vbulletin->GPC['catid']) . "'";
	}

	$result = $db->query_read("
		SELECT * 
		FROM " . TABLE_PREFIX . "vbentertain_item
		$where
		ORDER BY name ASC
	");

	$items = array();

	while ($item = $db->fetch_array($result))
	{
		$items[] = $item;
	}

	print_form_header('vbentertain', 'doexportitems', 0, 1, 'exportform');
	print_table_header($vbphrase['vbentertain_items_user_items_download']);

	foreach ($items AS $item)
	{
		$row = '<label for="cb' . $item['id'] . '"><input type="checkbox" id="cb' . $item['id'] . '" name="download[]" value="' . $item['id'] . '" /> ' . htmlentities($item['name']) . '</label>';
		print_description_row($row);
	}

	print_submit_row($vbphrase['vbentertain_items_user_download_button'], 0);
}

// ########################################################################
// finally export items 
if ($_REQUEST['do'] == 'doexportitems')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'filename' => TYPE_STR,
		'download' => TYPE_ARRAY_UINT,
	));

	if (empty($vbulletin->GPC['download']))
	{
		print_stop_message('please_complete_required_fields');
	}

	require_once(DIR . '/includes/class_xml.php');
	$xml = new vB_XML_Builder($vbulletin);
	$xml->add_group('items');

	$items = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "vbentertain_item WHERE id IN (" . implode(', ', $vbulletin->GPC['download']) . ")");

	while ($item = $db->fetch_array($items))
	{
		$xml->add_group('item');

		$xml->add_tag('name', $item['name']);
		$xml->add_tag('description', $item['description']);
		$xml->add_tag('streamhomepage', $item['streamhomepage']);
		$xml->add_tag('streamurl', $item['streamurl']);

		$xml->close_group();
	}

	$xml->close_group();

	$doc = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\r\n\r\n";
	$doc .= $xml->output();

	$xml = null;

	require_once(DIR . '/includes/functions_file.php');
	file_download($doc, 'vbentertain_items.xml', 'text/xml');
}

// ########################################################################
// delete items
if ($_REQUEST['do'] == 'deleteitems')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'catid' 	=> TYPE_UINT,
	));

	if ($vbulletin->GPC['catid'] == '0')
	{
		$where = '';
	} 
	else
	{
		$where = "WHERE categoryid = '" . intval($vbulletin->GPC['catid']) . "'";
	}

	$deleteitem = $db->query_write("
		DELETE FROM " . TABLE_PREFIX . "vbentertain_item
		$where
	");

	build_vbentertain_datastore(true);

	define('CP_REDIRECT', 'vbentertain.php?do=manageitems');
	print_stop_message('vbentertain_items_successfully_deleted');
}

// ########################################################################
// import items
if ($_REQUEST['do'] == 'importitems')
{
	$vbulletin->input->clean_array_gpc('f', array(
		'xmlfile'	=> TYPE_FILE
	));

	$vbulletin->input->clean_array_gpc('p', array(
		'catid' 	=> TYPE_UINT,
	));

	if ($vbulletin->GPC['catid'] == '0')
	{
		print_stop_message('vbentertain_items_import_wrong_category');
	} 

	if (file_exists($vbulletin->GPC['xmlfile']['tmp_name']))
	{
		$xml = file_read($vbulletin->GPC['xmlfile']['tmp_name']);
	}
	else
	{
		print_stop_message('vbentertain_items_import_mising_filename');
	}

	require_once(DIR . '/includes/class_xml.php');

	$xmlobj = new XMLparser($xml);

	if ($xmlobj->error_no == 1)
	{
		print_dots_stop();
		print_stop_message('no_xml_and_no_path');
	}
	else if ($xmlobj->error_no == 2)
	{
		print_dots_stop();
		print_stop_message('please_ensure_x_file_is_located_at_y', '', $vbulletin->GPC['path']);
	}

	if (empty($xmlobj->xmldata) OR $xmlobj->error_no > 0)
	{
		print_stop_message('vbentertain_items_import_unkown_xml_error', $xmlobj->error_no);
	}

	if ( !$xml_array = $xmlobj->parse() )
	{
		print_dots_stop();
		print_stop_message('xml_error_x_at_line_y', $xmlobj->error_string(), $xmlobj->error_line());
	}
	
	if (!empty($xml_array['item']['name']))
	{
		vbentertain_import_items($xml_array['station'], $vbulletin->GPC['catid']);
	}
	else
	{
		foreach ($xml_array['item'] AS $item)
		{
			vbentertain_import_items($item, $vbulletin->GPC['catid']);
		}
	}

	build_vbentertain_datastore(true);

	define('CP_REDIRECT', 'vbentertain.php?do=manageitems');
	print_stop_message('vbentertain_items_import_successfully');
}

// ########################################################################
// information
if ($_REQUEST['do'] == 'info')
{
	print_description_row($vbphrase['vbentertain_admincp_info']);
}

// ########################################################################
print_cp_footer();

?>