<?php
/*======================================================================*\
|| #################################################################### ||
|| # vBulletin-Entertain Version 1.0.0
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2007-2011, AddOn-Coders (http://www.addon-coders.de)  # ||
|| # ---------------------------------------------------------------- # ||
|| # Dateiname/filename: adminfunctions_vbentertain.php               # ||
|| # ---------------------------------------------------------------- # ||
|| # Support nur unter http://www.vbulletin-germany.org               # ||
|| # ---------------------------------------------------------------- # ||
|| # Dieses ist keine freie Software! nderungen, unerlaubtes Nutzen  # ||
|| # oder unerlaubte Verbreitung sind nicht erlaubt (auch nicht in    # ||
|| # Auszgen oder Einzelteilen) - This is not free software, changes # ||
|| # in and unallowed use of (parts from) this script is not allowed! # ||
|| #################################################################### ||
\*======================================================================*/

/**
* Build datastore for vB-Entertain.
*
* @Author	Vossi
*/
function build_vbentertain_datastore()
{
	global $vbulletin, $db;

	// set fields for datastore (array)
	$vbentertain_array = array(
		'categories' => array()
	);

	if ($vbulletin->options['vbentertain_displayorder'] == 0)
	{
		$sortfield = 'name';
	}
	else
	{
		$sortfield = 'displayorder';
	}

	// fetch all activecategories
	$cat_result = $vbulletin->db->query_read("
		SELECT *
		FROM " . TABLE_PREFIX . "vbentertain_category
		ORDER BY " . $sortfield . " ASC
	");

	while ($data = $db->fetch_array($cat_result))
	{
		$vbentertain_array['categories'][$data['id']] = $data;
	}

	unset($cat_result);

	// fetch amount of items and last items for each category
	if (count($vbentertain_array['categories']))
	{
		$items_result = $vbulletin->db->query_read("
			SELECT categoryid, COUNT(id) AS count, MAX(dateline) AS dateline, MAX(id) AS id
			FROM " . TABLE_PREFIX . "vbentertain_item
  			WHERE categoryid IN (" . implode( ',', array_keys($vbentertain_array['categories'])) . ")
  			AND status = 1
  			GROUP BY categoryid
		");

		while ($data = $db->fetch_array($items_result))
		{
			$vbentertain_array['categories'][$data['categoryid']]['itemsamount'] = $data['count'];
			$vbentertain_array['categories'][$data['categoryid']]['lastitemid'] = $data['id'];
		}

		unset($items_result);
	}

	// fetch usernames for every last item
	if (count($vbentertain_array['categories']))
	{
		// set -1 for root category
		$lastitemids = array(-1);

		foreach ($vbentertain_array['categories'] AS $cat => $data)
		{
			if (isset($data['lastitemid']))
			{
				$lastitemids[] = intval($data['lastitemid']);
			}
		}

		$userstats_result = $vbulletin->db->query_read("
			SELECT item.id, item.name, item.categoryid, item.userid, IF(NOT ISNULL(user.userid), user.username, item.username) AS username, item.dateline
			FROM " . TABLE_PREFIX . "vbentertain_item AS item
			LEFT JOIN " . TABLE_PREFIX . "user AS user USING(userid)
			WHERE item.id IN (" . implode( ',', $lastitemids) . ")
			AND item.status = 1;
		");

		while ($data = $db->fetch_array($userstats_result))
		{
			$vbentertain_array['categories'][$data['categoryid']]['lastitemusername'] = $data['username'];
			$vbentertain_array['categories'][$data['categoryid']]['lastitemuserid'] = $data['userid'];
			$vbentertain_array['categories'][$data['categoryid']]['lastitemid'] = $data['id'];
			$vbentertain_array['categories'][$data['categoryid']]['lastitemname'] = $data['name'];
			$vbentertain_array['categories'][$data['categoryid']]['lastitemdateline'] = $data['dateline'];
		}

		unset($userstats_result);
		unset($lastitemids);
	}

	build_datastore('vbentertain', serialize($vbentertain_array), true);
}

/**
* Import items for vB-Entertain.
*
* @param	item informations of file
*/
function vbentertain_import_items($item, $categoryid)
{
	global $vbulletin, $db, $vbphrase;

	if ($item_exists = $db->query_first_slave("
		SELECT streamurl 
		FROM " . TABLE_PREFIX . "vbentertain_item
		WHERE streamurl = '" . $item['streamurl'] . "'"
	))
	{
		echo $vbphrase['vbentertain_items_import_item_already_online'] . htmlentities($item['name']) . '<br />';
	}
	else
	{
		$db->query_write("INSERT INTO " . TABLE_PREFIX . "vbentertain_item (name, description, userid, username, dateline, categoryid, status, ipaddress, streamurl, streamhomepage) 
				VALUES
				(
					'" . $db->escape_string($item['name']) . "',
					'" . $db->escape_string($item['description']) . "',
					'" . intval($vbulletin->userinfo['userid']) . "',
					'" . $vbulletin->userinfo['username'] . "',
					'" . intval(TIMENOW) . "',
					'" . intval($categoryid) . "',
					'1',
					'" . $db->escape_string(IPADDRESS) . "',
					'" . $db->escape_string($item['streamurl']) . "',
					'" . $db->escape_string($item['streamhomepage']) . "'
				)
		");

		require_once (DIR . '/vb/search/indexcontroller/queue.php');
		vB_Search_Indexcontroller_Queue::indexQueue('vBEntertain', 'EntertainItem', 'index', $itemid);

		echo $vbphrase['vbentertain_items_import_item_imported'] . htmlentities($item['name']) . '<br />';
	}
}

?>