<?php if (!defined('VB_ENTRY')) die('Access denied.');
/*======================================================================*\
|| #################################################################### ||
|| # vBulletin-Entertain Version 1.0.0				      # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright ©2007-2011, AddOn-Coders (http://www.addon-coders.de)  # ||
|| # ---------------------------------------------------------------- # ||
|| # Dateiname/filename: vbmentertain.php                             # ||
|| # ---------------------------------------------------------------- # ||
|| # Support nur unter http://www.vbulletin-germany.org               # ||
|| # ---------------------------------------------------------------- # ||
|| # Dieses ist keine freie Software! Änderungen, unerlaubtes Nutzen  # ||
|| # oder unerlaubte Verbreitung sind nicht erlaubt (auch nicht in    # ||
|| # Auszügen oder Einzelteilen) - This is not free software, changes # ||
|| # in and unallowed use of (parts from) this script is not allowed! # ||
|| #################################################################### ||
\*======================================================================*/

require_once (DIR . '/vb/search/result.php');

/**
 * Restum Item Controller for entertain item
 *
 * @package vBulletin-Entertain
 * @subpackage Search
 */
class vBEntertain_Search_Result_EntertainItem extends vB_Search_Result
{
	protected $preview_length = 200;

	public static function create($id)
	{
		$items = self::create_array(array($id));
		if (count($items))
		{
			return array_shift($items);
		}
		else
		{
			//invalid object.
			return new vBEntertain_Search_Result_EntertainItem();
		}
	}

	public static function create_array($ids)
	{
		global $vbulletin, $usercache;

		if (
			!($vbulletin->userinfo['permissions']['vbentertain_general_permissions'] & $vbulletin->bf_ugp_vbentertain_general_permissions['can_enter'])
		)
		{
			// no permission to view entertain or entertain items
			return array();
		}

		$groupsql = array();
		foreach (fetch_membergroupids_array($vbulletin->userinfo) AS $usergroupid)
		{
			$groupsql[] = "FIND_IN_SET($usergroupid, vbentertain_category.groupshowlist)";
		}

		$set = $vbulletin->db->query_read_slave("
			SELECT item.*, vbentertain_category.name AS categoryname
			FROM " . TABLE_PREFIX ."vbentertain_item AS item
			INNER JOIN " . TABLE_PREFIX . "vbentertain_category AS vbentertain_category ON (vbentertain_category.id = item.categoryid AND (vbentertain_category.groupshow = 1 OR " . implode(' OR ', $groupsql) . "))
			WHERE item.id IN (" . implode(',', array_map('intval', $ids)) . ")
			" . ((!($vbulletin->userinfo['permissions']['vbentertain_general_permissions'] & $vbulletin->bf_ugp_vbentertain_general_permissions['can_admin'])) ? "AND item.status = 1" : "") . "
		");

		$items = array();
		while ($record = $vbulletin->db->fetch_array($set))
		{
			$item = new vBEntertain_Search_Result_EntertainItem();
			$item->record = $record;
			$items[$record['id']] = $item;
		}

		return $items;
	}

	public function create_from_record($record)
	{
		$item = new vBEntertain_Search_Result_EntertainItem();
		$item->record = $record;
		return $item;
	}

	protected function __construct() {}

	public function get_contenttype()
	{
		return vB_Search_Core::get_instance()->get_contenttypeid('vBEntertain', 'EntertainItem');
	}

	public function can_search($user)
	{
		//if we sucessfully loaded it, we can search on it.
		return (bool) $this->record;
	}

	public function render($current_user, $criteria, $template_name = '')
	{
		if (!$this->record)
		{
			return "";
		}

		if (!$template_name)
		{
			$template_name = 'vbentertain_search_result_item';
		}
		
		$item = $this->record;
		
		$item['previewtext']  = htmlspecialchars_uni(fetch_censored_text(
			fetch_trimmed_title(strip_bbcode($item['description'], true, true, true, true),
					$this->preview_length)
		));

		$templater = vB_Template::create($template_name);
		$templater->register('item', $item);
		return $templater->render();
	}

	public function get_record()
	{
		return $this->record;
	}

	/*** Returns the primary id. Allows us to cache a result item.
	 *
	 * @result	integer
	 ***/
	public function get_id()
	{
		if (isset($this->record) AND isset($this->record['id']) )
		{
			return $this->record['id'];
		}
		return false;
	}

	private $record = null;
}

?>