<?php
/*======================================================================*\
|| #################################################################### ||
|| # vBulletin-Entertain Version 1.0.1				      # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2007-2011, AddOn-Coders (http://www.addon-coders.de)  # ||
|| # ---------------------------------------------------------------- # ||
|| # Dateiname/filename: vbmentertain.php                             # ||
|| # ---------------------------------------------------------------- # ||
|| # Support nur unter http://www.vbulletin-germany.org               # ||
|| # ---------------------------------------------------------------- # ||
|| # Dieses ist keine freie Software! nderungen, unerlaubtes Nutzen  # ||
|| # oder unerlaubte Verbreitung sind nicht erlaubt (auch nicht in    # ||
|| # Auszgen oder Einzelteilen) - This is not free software, changes # ||
|| # in and unallowed use of (parts from) this script is not allowed! # ||
|| #################################################################### ||
\*======================================================================*/

// ####################### SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### DEFINE IMPORTANT CONSTANTS #######################
define('GET_EDIT_TEMPLATES', 'editaboutme, updateaboutme');
define('VB_PRODUCT', 'vbentertain');
define('THIS_SCRIPT', 'vbentertain');
define('CSRF_PROTECTION', true);
define('GET_EDIT_TEMPLATES', 'comment');

// ################### PRE-CACHE TEMPLATES AND DATA ######################
// pre-cache templates used by all actions
$globaltemplates = array(
	'vbentertain_home',
	'vbentertain_home_item',
	'vbentertain_player_media_player',
	'vbentertain_player_real_player',
	'vbentertain_player_quicktime_player',
	'vbentertain_player_defined',
	'vbentertain_select_complete',
	'vbentertain_select_item_start',
	'vbentertain_new_comments_bit',
	'vbentertain_new_items_bit'
);

// get special phrase groups
$phrasegroups = array(
	'vbentertain',
	'user',
	'posting',
	'cppermission',
	'timezone'
);

// get special data templates from the datastore
$specialtemplates = array(
	'smiliecache',
	'bbcodecache',
	'vbentertain'
);

// pre-cache templates used by specific actions
$actiontemplates = array(
	'movie' => array(
		'vbentertain_movie'
	),
	'create' => array(
		'vbentertain_create'
	),
	'comment' => array(
		'vbentertain_edit_comment'
	),
	'delete' => array(
		'vbentertain_delete'
	),
);

// ######################### REQUIRE BACK-END ############################
require_once('./global.php');
require_once(DIR . '/includes/functions_misc.php');
require_once(DIR . '/includes/functions_vbentertain.php');
require_once(DIR . '/includes/functions_bigthree.php');

// bootstrap framework
require_once(DIR . '/includes/class_bootstrap_framework.php');
vB_Bootstrap_Framework::init();

// ######################### CHECK PERMISSIONS ############################
if (!($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_enter']))
{
	print_no_permission();
}

// #######################################################################
// ######################## START MAIN SCRIPT ############################
// #######################################################################

// main script
if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'home';
}

// #######################################################################
if ($_POST['do'] == 'updatecomment')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'commentid'	=> TYPE_INT,
		'itemid'	=> TYPE_INT,
		'comment'	=> TYPE_NOHTML,
	));

	($hook = vBulletinHook::fetch_hook('vbentertain_update_comment_start')) ? eval($hook) : false;

	// item available?
	if ($item = $db->query_first("
		SELECT *
		$hook_query_fields
		FROM " . TABLE_PREFIX . "vbentertain_item
		WHERE id = '" . intval($vbulletin->GPC['itemid']) . "'
		$hook_query_joins
	"))
	{
		($hook = vBulletinHook::fetch_hook('vbentertain_fetch_iteminfo_update_comment')) ? eval($hook) : false;
		$itemid = intval($vbulletin->GPC['itemid']);
	}
	else
	{
		eval(standard_error(fetch_error('invalidid', $vbphrase['vbentertain_comment'], $vbulletin->options['contactuslink'])));
	}

	// comment available?
	if ($comment = $db->query_first("
		SELECT *
		FROM " . TABLE_PREFIX . "vbentertain_comment
		WHERE commentid = " . intval($vbulletin->GPC['commentid']) . "
	"))
	{
		$commentid = $vbulletin->GPC['commentid'];
	}

#	if ((!$permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_admin']) OR (!$permissions['vbentertain_comment_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_comment'] AND $comment['postuserid'] == $vbulletin->userinfo['userid']))
	if ((!$permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_admin']) OR (!$permissions['vbentertain_comment_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_comment']))
	{
		print_no_permission();
	}

	$description = $vbulletin->GPC['comment'];

	$textlen = vbstrlen(strip_bbcode($description, $vbulletin->options['ignorequotechars']));

	if ($textlen < $vbulletin->options['vbentertain_commentminchars'])
	{
		eval(standard_error(fetch_error('tooshort', $vbulletin->options['vbentertain_commentminchars'], $vbulletin->options['contactuslink'])));
	}
	else if ($textlen > $vbulletin->options['vbentertain_commentmaxchars'])
	{
		eval(standard_error(fetch_error('toolong', $vbulletin->options['vbentertain_commentmaxchars'], $vbulletin->options['contactuslink'])));
	}

	require_once(DIR . '/includes/functions_newpost.php');

	$description = preg_replace('/&#(0*32|x0*20);/', ' ', $description);
	$description = trim($description);

	// add # to color tags using hex if it's not there
	$description = preg_replace('#\[color=(&quot;|"|\'|)([a-f0-9]{6})\\1]#i', '[color=\1#\2\1]', $description);

	// strip alignment codes that are closed and then immediately reopened
	$description = preg_replace('#\[/(left|center|right)]((\r\n|\r|\n)*)\[\\1]#si', '\\2', $description);

	// censor main message text
	$description = fetch_censored_text($description);

	// parse URLs in message text
	if ($vbulletin->info['parseurl'])
	{
		$description = convert_url_to_bbcode($description);
	}

	$description = fetch_no_shouting_text($description);

	if ($commentid)
	{
		// update comment as we got the itemid
		$db->query_write("UPDATE " . TABLE_PREFIX . "vbentertain_comment SET 
				pagetext = '" . $db->escape_string($description) . "',
			WHERE commentid = " . intval($commentid) . " 
		");

		($hook = vBulletinHook::fetch_hook('vbentertain_update_comment_complete')) ? eval($hook) : false;

		// fetch catid of existing itemid
		$iteminfo = $db->query_first("
			SELECT *
			FROM " . TABLE_PREFIX . "vbentertain_item
			WHERE id = " . intval($itemid) . "
		");

		$vbulletin->url = 'vbentertain.php?' . $vbulletin->session->vars['sessionurl'] . 'do=home&amp;catid=' . $item['categoryid'] . '&amp;id=' . $itemid;
		eval(print_standard_redirect('vbentertain_item_sucessfully_updated'));
	}
	else
	{
		// new comment as no commentid available
		$db->query_write("INSERT INTO " . TABLE_PREFIX . "vbentertain_comment (itemid, postuserid, postusername, ipaddress, dateline, state, pagetext)
		VALUES (
			'" . intval($itemid) . "',
			'" . intval($vbulletin->userinfo['userid']) . "',
			'" . $db->escape_string($vbulletin->userinfo['username']) . "',
			'" . $db->escape_string(IPADDRESS) . "',
			'" . intval(TIMENOW) . "',
			'visible',
			'" . $db->escape_string($description) . "'
		)");

		($hook = vBulletinHook::fetch_hook('vbentertain_update_comment_complete')) ? eval($hook) : false;

		// fetch catid of existing itemid
		$iteminfo = $db->query_first("
			SELECT *
			FROM " . TABLE_PREFIX . "vbentertain_item
			WHERE id = " . intval($itemid) . "
		");

		$vbulletin->url = 'vbentertain.php?' . $vbulletin->session->vars['sessionurl'] . 'do=home&amp;catid=' . $iteminfo['categoryid'] . '&amp;id=' . $itemid;
		eval(print_standard_redirect('vbentertain_item_sucessfully_added'));
	}

	($hook = vBulletinHook::fetch_hook('vbentertain_update_comment_complete')) ? eval($hook) : false;

	$vbulletin->url = 'vbentertain.php?' . $vbulletin->session->vars['sessionurl'] . 'do=home';
	eval(print_standard_redirect('vbentertain_comment_not_sucessfully_edited'));
}

// #######################################################################
if ($_REQUEST['do'] == 'comment')
{
	if (!($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_admin']) OR !($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_comment']))
	{
		print_no_permission();
	}

	$vbulletin->input->clean_array_gpc('g', array(
		'id'		=> TYPE_INT,
		'commentid'	=> TYPE_INT
	));

	($hook = vBulletinHook::fetch_hook('vbentertain_comment_start')) ? eval($hook) : false;

	if ($item = $db->query_first("
		SELECT *
		$hook_query_fields
		FROM " . TABLE_PREFIX . "vbentertain_item
		WHERE id = '" . intval($vbulletin->GPC['id']) . "'
		$hook_query_joins
	"))
	{
		($hook = vBulletinHook::fetch_hook('vbentertain_fetch_iteminfo_comment')) ? eval($hook) : false;
		$id = intval($vbulletin->GPC['id']);
	}
	else
	{
		eval(standard_error(fetch_error('invalidid', $vbphrase['vbentertain_item'], $vbulletin->options['contactuslink'])));
	}

	// comment available?
	$show['edit'] = true;

	if (!$comment = $db->query_first("
		SELECT *
		FROM " . TABLE_PREFIX . "vbentertain_comment
		WHERE commentid = " . intval($vbulletin->GPC['commentid']) . "
	"))
	{
		$show['edit'] = false;
	}

	($hook = vBulletinHook::fetch_hook('vbentertain_comment_message_complete')) ? eval($hook) : false;

	// navbar and output
	$navbits = construct_navbits(array(
		'vbentertain.php' . $vbulletin->session->vars['sessionurl_q'] => $vbphrase['vbentertain_navbit_headline'],
		'' => $vbphrase['vbentertain_navbit_comment_item']
	));

	$navbar = render_navbar_template($navbits);

	($hook = vBulletinHook::fetch_hook('vbentertain_comment_complete')) ? eval($hook) : false;

	$templater = vB_Template::create('vbentertain_edit_comment');
		$templater->register_page_templates();
		$templater->register('navbar', $navbar);
		$templater->register('comment', $comment);
		$templater->register('item', $item);
	print_output($templater->render());
}

// #######################################################################
if ($_REQUEST['do'] == 'delete')
{
	if (!($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_admin']) OR !($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_delete_own']))
	{
		print_no_permission();
	}

	$vbulletin->input->clean_array_gpc('g', array(
		'id'		=> TYPE_INT
	));

	($hook = vBulletinHook::fetch_hook('vbentertain_delete_start')) ? eval($hook) : false;

	$hook_query_fields = $hook_query_joins = '';
	($hook = vBulletinHook::fetch_hook('vbentertain_fetch_iteminfo_delete_query')) ? eval($hook) : false;

	if ($item = $db->query_first("
		SELECT *
		$hook_query_fields
		FROM " . TABLE_PREFIX . "vbentertain_item
		WHERE id = '" . intval($vbulletin->GPC['id']) . "'
		$hook_query_joins
	"))
	{
		($hook = vBulletinHook::fetch_hook('vbentertain_fetch_iteminfo_delete')) ? eval($hook) : false;
		$id = intval($vbulletin->GPC['id']);
	}
	else
	{
		eval(standard_error(fetch_error('invalidid', $vbphrase['vbentertain_item'], $vbulletin->options['contactuslink'])));
	}

	// navbar and output
	$navbits = construct_navbits(array(
		'vbentertain.php' . $vbulletin->session->vars['sessionurl_q'] => $vbphrase['vbentertain_navbit_headline'],
		'' => $vbphrase['vbentertain_navbit_delete_item']
	));

	$navbar = render_navbar_template($navbits);

	($hook = vBulletinHook::fetch_hook('vbentertain_delete_complete')) ? eval($hook) : false;

	$templater = vB_Template::create('vbentertain_delete');
		$templater->register_page_templates();
		$templater->register('navbar', $navbar);
		$templater->register('id', $id);
		$templater->register('item', $item);
	print_output($templater->render());
}

// #######################################################################
if ($_REQUEST['do'] == 'kill')
{
	if (!($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_admin']) OR !($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_delete_own']))
	{
		print_no_permission();
	}

	$vbulletin->input->clean_array_gpc('p', array(
		'id'		=> TYPE_INT,
		'deletetype'	=> TYPE_INT
	));

	($hook = vBulletinHook::fetch_hook('vbentertain_kill_start')) ? eval($hook) : false;

	$hook_query_fields = $hook_query_joins = '';
	($hook = vBulletinHook::fetch_hook('vbentertain_fetch_iteminfo_kill_query')) ? eval($hook) : false;

	if (!$item = $db->query_first("
		SELECT *
		$hook_query_fields
		FROM " . TABLE_PREFIX . "vbentertain_item
		WHERE id = '" . intval($vbulletin->GPC['id']) . "'
		$hook_query_joins
	"))
	{
		eval(standard_error(fetch_error('invalidid', $vbphrase['vbentertain_item'], $vbulletin->options['contactuslink'])));
	}

	if ($vbulletin->GPC['deletetype'])
	{
		$delete = $db->query_write("
			DELETE FROM " . TABLE_PREFIX . "vbentertain_item
			WHERE id = '" . intval($item['id']) . "'
		");


		// rebuild datastore
		require_once(DIR . '/includes/adminfunctions_vbentertain.php');
		build_vbentertain_datastore();

		require_once (DIR . '/vb/search/indexcontroller/queue.php');
		vB_Search_Indexcontroller_Queue::indexQueue('vBEntertain', 'EntertainItem', 'delete', $item['id']);

		$vbulletin->url = 'vbentertain.php?' . $vbulletin->session->vars['sessionurl'] . 'do=home';
		eval(print_standard_redirect('vbentertain_item_successfully_deleted'));
	}
	else
	{
		$vbulletin->url = 'vbentertain.php?' . $vbulletin->session->vars['sessionurl'] . 'do=home';
		eval(print_standard_redirect('vbentertain_item_not_successfully_deleted'));
	}
}

// #######################################################################
if ($_REQUEST['do'] == 'create')
{
	if (!($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_admin']) OR !($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_change_own']) OR !($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_add']))
	{
		print_no_permission();
	}

	$vbulletin->input->clean_array_gpc('g', array(
		'id'		=> TYPE_INT
	));

	($hook = vBulletinHook::fetch_hook('vbentertain_create_start')) ? eval($hook) : false;

	$hook_query_fields = $hook_query_joins = '';
	($hook = vBulletinHook::fetch_hook('vbentertain_fetch_iteminfo_create_query')) ? eval($hook) : false;

	if ($item = $db->query_first("
		SELECT *
		$hook_query_fields
		FROM " . TABLE_PREFIX . "vbentertain_item
		WHERE id = '" . intval($vbulletin->GPC['id']) . "'
		$hook_query_joins
	"))
	{
		($hook = vBulletinHook::fetch_hook('vbentertain_fetch_iteminfo_create')) ? eval($hook) : false;
		$itemid = intval($vbulletin->GPC['id']);
	}
	else
	{
		$itemid = '';
	}

	// build categories
	$categoryselect = '';

	$catcache = $vbulletin->vbentertain['categories'];

	// if there are categories
	if (count($catcache))
	{
		foreach ($catcache AS $row)
		{
			// is this category a main category?
			if ($row['parentid'] == -1 AND $row['status'] > 0)
			{
				if (fetch_entertain_catpermission($row['id'], false))
				{
					$templater = vB_Template::create('option');
						$templater->register('optionvalue', $row['id']);
						$templater->register('optiontitle', $row['name']);
						$templater->register('optionselected', $optionselected);
					$categoryselect .= $templater->render();

					// are there subcategories in this category?
					foreach ($catcache AS $subrow)
					{
						if ($subrow['parentid'] == $row['id'] AND $subrow['status'] > 0)
						{
							if (fetch_entertain_catpermission($subrow['id'], false))
							{
								$templater = vB_Template::create('option');
									$templater->register('optionvalue', $subrow['id']);
									$templater->register('optiontitle', '-- ' . $subrow['name']);
									$templater->register('optionselected', $optionselected);
								$categoryselect .= $templater->render();
							}
						}
					}
				}
			}
		}
	}

	// navbar and output
	$navbits = construct_navbits(array(
		'vbentertain.php' . $vbulletin->session->vars['sessionurl_q'] => $vbphrase['vbentertain_navbit_headline'],
		'' => $vbphrase['vbentertain_navbit_new_item']
	));

	$navbar = render_navbar_template($navbits);

	($hook = vBulletinHook::fetch_hook('vbentertain_create_complete')) ? eval($hook) : false;

	$templater = vB_Template::create('vbentertain_create');
		$templater->register_page_templates();
		$templater->register('navbar', $navbar);
		$templater->register('categoryselect', $categoryselect);
		$templater->register('item', $item);
	print_output($templater->render());
}

// #######################################################################
if ($_POST['do'] == 'update')
{
	if (!($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_admin']) OR !($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_change_own']) OR !($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_add']))
	{
		print_no_permission();
	}

	$vbulletin->input->clean_array_gpc('p', array(
		'categoryid'		=> TYPE_INT,
		'name'			=> TYPE_NOHTML,
		'streamhompepage'	=> TYPE_NOHTML,
		'streamurl'		=> TYPE_NOHTML,
		'description'		=> TYPE_NOHTML,
		'itemid'		=> TYPE_INT
	));

	($hook = vBulletinHook::fetch_hook('vbentertain_update_start')) ? eval($hook) : false;

	// check if category exists
	if (!($catinfo = fetch_entertain_catinfo($vbulletin->GPC['categoryid'])))
	{
		eval(standard_error(fetch_error('invalidid', $vbphrase['vbentertain_category'], $vbulletin->options['contactuslink'])));
	}

	$hook_query_fields = $hook_query_joins = '';
	($hook = vBulletinHook::fetch_hook('vbentertain_fetch_iteminfo_update_query')) ? eval($hook) : false;

	if ($itemexists = $db->query_first("
		SELECT *
		$hook_query_fields
		FROM " . TABLE_PREFIX . "vbentertain_item
		WHERE id = '" . intval($vbulletin->GPC['itemid']) . "'
		$hook_query_joins
	"))
	{
		($hook = vBulletinHook::fetch_hook('vbentertain_fetch_iteminfo_update')) ? eval($hook) : false;
		$itemid = intval($vbulletin->GPC['itemid']);
	}
	else
	{
		$itemid = '';
	}

	// check if name is correct, has allowed length and doesnt contain crap
	$name = preg_replace('/&#(0*32|x0*20);/', ' ', $vbulletin->GPC['name']);
	$name = trim($name);

	$titlelen = vbstrlen($name);

	if ($titlelen < $vbulletin->options['vbentertain_titleminchars'])
	{
		eval(standard_error(fetch_error('vbentertain_entry_name_too_short', $vbulletin->options['vbentertain_titleminchars'], $titlelen)));
	}
	else if ($titlelen > $vbulletin->options['vbentertain_titlemaxchars'])
	{
		eval(standard_error(fetch_error('vbentertain_entry_name_too_long', $vbulletin->options['vbentertain_titlemaxchars'], $titlelen)));
	}

	$name = htmlspecialchars_uni($name);

	if ($name != fetch_censored_text($name))
	{
		eval(standard_error(fetch_error('vbentertain_entry_name_contains_censored_words')));
	}

	// check if homepageurl is has been entered and doesnt contain crap
	if ($vbulletin->GPC['streamhompepage'] == '' AND $vbulletin->options['vbentertain_check_streamhomepage'] == '1')
	{
		eval(standard_error(fetch_error('vbentertain_no_homepageurl')));
	}
	else
	{
		$homepageurl = preg_replace('/&#(0*32|x0*20);/', ' ', $vbulletin->GPC['streamhompepage']);
		$homepageurl = trim($homepageurl);

		$homepageurl = htmlspecialchars_uni($homepageurl);

		if ($homepageurl != fetch_censored_text($homepageurl))
		{
			eval(standard_error(fetch_error('vbentertain_homepageurl_contains_censored_words')));
		}

		// check URL for complete insert
		if ($homepageurl)
		{
			if(!preg_match('/^(http|https|ftp)\:\/\/([a-z0-9-\.]+)[a-z0-9-]+\.[a-z]{2,4}\b/', $homepageurl))
			{ 
				$homepageurl = 'http://' . $homepageurl; 
			}
		}
	}

	// check if streamurl is has been entered and doesnt contain crap
	if ($vbulletin->GPC['streamurl'] == '')
	{
		eval(standard_error(fetch_error('vbentertain_no_streamurl')));
	}
	else
	{
		$streamurl = preg_replace('/&#(0*32|x0*20);/', ' ', $vbulletin->GPC['streamurl']);
		$streamurl = trim($streamurl);

		$streamurl = htmlspecialchars_uni($streamurl);

		if ($streamurl != fetch_censored_text($streamurl))
		{
			eval(standard_error(fetch_error('vbentertain_homepageurl_contains_censored_words')));
		}

		// check URL for complete insert
		if ($streamurl)
		{
			if(!preg_match('/^(http|https|ftp)\:\/\/([a-z0-9-\.]+)[a-z0-9-]+\.[a-z]{2,4}\b/', $streamurl))
			{ 
				$streamurl = 'http://' . $streamurl; 
			}
		}

		// check if url is a duplicate
		$url_duplicate = $streamurl;

		if ($vbulletin->options['vbentertain_check_duplicates'] AND !$itemid)
		{
			$matches = substr($url_duplicate, 0, 7);

			if ($matches=='http://')
			{
				$url_duplicate = substr($url_duplicate, 7);
			}
			else
			{
				$matches = substr($url_duplicate, 0, 8);

				if ($matches=='https://')
				{
					$url_duplicate = substr($url_duplicate, 8);
				}
			}

			$duplicatelist = $db->query_read("
				SELECT streamurl, id
				FROM " . TABLE_PREFIX . "vbentertain_item AS item
				WHERE streamurl LIKE '%" . $db->escape_string_like($url_duplicate) . "%'
			");

			$entriestotal = $db->found_rows();

			if ($entriestotal)
			{
				while ($row = $db->fetch_array($duplicatelist))
				{
					$matches = substr($row['streamurl'], 0, 7);

					if ($matches=='http://')
					{
						$row['streamurl'] = substr($row['streamurl'], 7);
					}
					else
					{
						$matches = substr($url_duplicate, 0, 8);

						if ($matches=='https://')
						{
							$row['streamurl'] = substr($row['streamurl'], 8);
						}
					}

					if ($row['streamurl'] == $url_duplicate AND $row['id'] != $entry['id'])
					{
						eval(standard_error(fetch_error('vbentertain_duplicate_item')));
					}
				}
			}
		}

		// check if url is on blacklist
		$url_blacklist = $streamurl;

		if ($vbulletin->options['vbentertain_blacklist'])
		{
			$blacklist_array = explode(',', $vbulletin->options['vbentertain_blacklist']);  

			$matches = substr($url_blacklist, 0, 7);

			if ($matches=='http://')
			{
				$url_blacklist = substr($url_blacklist, 7);
			}
			else
			{
				$matches = substr($url_blacklist, 0, 8);

				if ($matches=='https://')
				{
					$url_blacklist = substr($url_blacklist, 8);
				}
			}

			if (in_array($url_blacklist, $blacklist_array))
			{
				eval(standard_error(fetch_error('vbentertain_blacklisted_item')));
			}
		}
	}

	// check if homepageurl is has been entered and doesnt contain crap
	if ($vbulletin->GPC['description'] == '' AND $vbulletin->options['vbentertain_check_description'] == '1')
	{
		eval(standard_error(fetch_error('vbentertain_no_homepageurl')));
	}
	else
	{
		$description = $vbulletin->GPC['description'];

		$textlen = vbstrlen(strip_bbcode($description, $vbulletin->options['ignorequotechars']));

		if ($textlen < $vbulletin->options['vbentertain_entryminchars'])
		{
			eval(standard_error(fetch_error('vbentertain_description_too_short', $vbulletin->options['vbentertain_entryminchars'], $textlen)));
		}
		else if ($textlen > $vbulletin->options['vbentertain_entrymaxchars'])
		{
			eval(standard_error(fetch_error('vbentertain_description_too_long', $vbulletin->options['vbentertain_entrymaxchars'], $textlen)));
		}

		require_once(DIR . '/includes/functions_newpost.php');

		$description = preg_replace('/&#(0*32|x0*20);/', ' ', $description);
		$description = trim($description);

		// add # to color tags using hex if it's not there
		$description = preg_replace('#\[color=(&quot;|"|\'|)([a-f0-9]{6})\\1]#i', '[color=\1#\2\1]', $description);

		// strip alignment codes that are closed and then immediately reopened
		$description = preg_replace('#\[/(left|center|right)]((\r\n|\r|\n)*)\[\\1]#si', '\\2', $description);

		// censor main message text
		$description = fetch_censored_text($description);

		// parse URLs in message text
		if ($vbulletin->info['parseurl'])
		{
			$description = convert_url_to_bbcode($description);
		}

		$description = fetch_no_shouting_text($description);
	}

	if (($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_moderate']) AND !($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_admin']))
	{
		$status = '0 ';
	}
	else
	{
		$status = '1 ';
	}

	if ($itemid)
	{
		// update item as we got the itemid
		$db->query_write("UPDATE " . TABLE_PREFIX . "vbentertain_item SET 
				name = '" . $db->escape_string($name) . "',
				description = '" . $db->escape_string($description) . "',
				userid = '" . intval($vbulletin->userinfo['userid']) . "',
				username = '" . $db->escape_string($vbulletin->userinfo['username']) . "',
				dateline = '" . intval(TIMENOW) . "',
				categoryid = '" . intval($vbulletin->GPC['categoryid']) . "',
				status = '" . intval($status) . "',
				ipaddress = '" . $db->escape_string(IPADDRESS) . "',
				streamurl = '" . $db->escape_string($streamurl) . "',
				streamhomepage = '" . $db->escape_string($homepageurl) . "'
			WHERE id = " . intval($itemid) . " 
		");

		// rebuild datastore
		require_once(DIR . '/includes/adminfunctions_vbentertain.php');
		build_vbentertain_datastore();

		require_once (DIR . '/vb/search/indexcontroller/queue.php');
		vB_Search_Indexcontroller_Queue::indexQueue('vBEntertain', 'EntertainItem', 'index', $itemid);

		($hook = vBulletinHook::fetch_hook('vbentertain_update_complete')) ? eval($hook) : false;

		$vbulletin->url = 'vbentertain.php?' . $vbulletin->session->vars['sessionurl'] . 'do=home&amp;catid=' . intval($vbulletin->GPC['categoryid']) . '&amp;id=' . $itemid;
		eval(print_standard_redirect('vbentertain_item_sucessfully_updated'));
	}
	else
	{
		$dateline_check = TIMENOW;

		// new item as no itemid available
		$db->query_write("INSERT INTO " . TABLE_PREFIX . "vbentertain_item (name, description, userid, username, dateline, categoryid, status, ipaddress, streamurl, streamhomepage, views, votenum, votetotal)
		VALUES (
			'" . $db->escape_string($name) . "',
			'" . $db->escape_string($description) . "',
			'" . intval($vbulletin->userinfo['userid']) . "',
			'" . $db->escape_string($vbulletin->userinfo['username']) . "',
			'" . intval($dateline_check) . "',
			'" . intval($vbulletin->GPC['categoryid']) . "',
			'" . intval($status) . "',
			'" . $db->escape_string(IPADDRESS) . "',
			'" . $db->escape_string($streamurl) . "',
			'" . $db->escape_string($homepageurl) . "',
			'0',
			'0',
			'0'
		)");

		// rebuild datastore
		require_once(DIR . '/includes/adminfunctions_vbentertain.php');
		build_vbentertain_datastore();

		// fetch new id of item
		$iteminfo = $db->query_first("
			SELECT *
			FROM " . TABLE_PREFIX . "vbentertain_item
			WHERE name = '" . $db->escape_string($name) . "'
			AND dateline = " . intval($dateline_check) . "
		");

		require_once (DIR . '/vb/search/indexcontroller/queue.php');
		vB_Search_Indexcontroller_Queue::indexQueue('vBEntertain', 'EntertainItem', 'index', $itemid);

		($hook = vBulletinHook::fetch_hook('vbentertain_update_complete')) ? eval($hook) : false;

		$vbulletin->url = 'vbentertain.php?' . $vbulletin->session->vars['sessionurl'] . 'do=home&amp;catid=' . intval($vbulletin->GPC['categoryid']) . '&amp;id=' . $iteminfo['id'];
		eval(print_standard_redirect('vbentertain_item_sucessfully_added'));
	}

	($hook = vBulletinHook::fetch_hook('vbentertain_update_complete')) ? eval($hook) : false;

	$vbulletin->url = 'vbentertain.php?' . $vbulletin->session->vars['sessionurl'] . 'do=home';
	eval(print_standard_redirect('vbentertain_item_not_sucessfully_edited'));
}

// #######################################################################
if ($_REQUEST['do'] == 'movie')
{
#	if (!($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_admin']) OR !($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_movie']) )
#	{
#		print_no_permission();
#	}

	if (!($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_movie']))
	{
echo'2';		print_no_permission();
	}

	($hook = vBulletinHook::fetch_hook('vbentertain_movie_start')) ? eval($hook) : false;

	// movie informations
	$movie['name'] = $vbulletin->options['vbentertain_movie_name'];
	$show['name'] = ($vbulletin->options['vbentertain_movie_name'] ? true : false);
	$show['movie'] = ($vbulletin->options['vbentertain_movie_active'] ? true : false);

	// fetch player
	$player['height'] = $vbulletin->options['vbentertain_movie_player_height'];
	$player['width'] = $vbulletin->options['vbentertain_movie_player_width'];
	$player['autostart_num'] = $vbulletin->options['vbentertain_movie_player_autostart'];
	$player['autostart_boo'] = ($vbulletin->options['vbentertain_movie_player_autostart'] ? true : false);
	$player['url'] = $vbulletin->options['vbentertain_movie_address'];

	switch ($vbulletin->options['vbentertain_movie_playerid'])
	{
		case '0':
			$defined = '';
			$player_template = 'vbentertain_player_real_player';
			break;
		case '1':
			$defined = '';
			$player_template = 'vbentertain_player_quicktime_player';
			break;
		case '2':
			$defined = '';
			$player_template = 'vbentertain_player_media_player';
			break;
		case '3':
			if ($vbulletin->options['vbentertain_movie_player_defined'])
			{
				$defined = $vbulletin->options['vbentertain_movie_player_defined'];
				$player_template = 'vbentertain_player_defined';
			}
			else
			{
				$defined = '';
				$player_template = 'vbentertain_player_media_player';
			}
			break;
		default:
			$defined = '';
			$player_template = 'vbentertain_player_media_player';
			break;
	}

	$templater = vB_Template::create($player_template);
		$templater->register('defined', $defined);
		$templater->register('player', $player);
		$templater->register('playerid', $vbulletin->options['vbentertain_movie_playerid']);
	$player = $templater->render();

	// navbar and output
	$navbits = construct_navbits(array(
		'vbentertain.php' . $vbulletin->session->vars['sessionurl_q'] => $vbphrase['vbentertain_navbit_headline'],
		'' => $vbphrase['vbentertain_navbit_movie']
	));

	$navbar = render_navbar_template($navbits);

	($hook = vBulletinHook::fetch_hook('vbentertain_movie_complete')) ? eval($hook) : false;

	$templater = vB_Template::create('vbentertain_movie');
		$templater->register_page_templates();
		$templater->register('navbar', $navbar);
		$templater->register('player', $player);
		$templater->register('movie', $movie);
	print_output($templater->render());
}

// #######################################################################
if ($_REQUEST['do'] == 'home')
{
	($hook = vBulletinHook::fetch_hook('vbentertain_home_start')) ? eval($hook) : false;

	$vbulletin->input->clean_array_gpc('g', array(
		'catid'	=> TYPE_INT,
		'id' 	=> TYPE_INT
	));

	($hook = vBulletinHook::fetch_hook('vbentertain_home_start')) ? eval($hook) : false;

	if ($vbulletin->GPC['id'])
	{
		$catid = $vbulletin->GPC['catid'];
		$itemid = $vbulletin->GPC['id'];
	}
	else
	{
		$first_cat = $db->query_first("
			SELECT *
			FROM " . TABLE_PREFIX . "vbentertain_category
			WHERE status = '1'
			AND parentid = '-1'
			ORDER BY id asc
			LIMIT 1
		");
		$catid = $first_cat['id'];

		$first_item = $db->query_first("
			SELECT *
			FROM " . TABLE_PREFIX . "vbentertain_item
			WHERE status = '1'
			AND categoryid = '" . intval($catid) . "'
			ORDER BY id asc
			LIMIT 1
		");
		$itemid = $first_item['id'];
	}

	// framework
	require_once(DIR . '/includes/class_bootstrap_framework.php');
	require_once(DIR . '/vb/types.php');
	vB_Bootstrap_Framework::init();
	$types = vB_Types::instance();
	$contenttypeid = intval($types->getContentTypeID('vBEntertain_EntertainItem'));

	// build categories
	$categoryselect = $itemselect = '';
	$show['category'] = false;

	$catcache = $vbulletin->vbentertain['categories'];

	// if there are categories
	if (count($catcache))
	{
		foreach ($catcache AS $row)
		{
			// is this category a main category?
			if ($row['parentid'] == -1 AND $row['status'] > 0)
			{
				if (fetch_entertain_catpermission($row['id'], false))
				{
					$show['category'] = true;

					$optionvalue =& $row['id'];
					$optiontitle =& $row['name'];
					$optionselected = ($catid == $row['id']) ? 'selected="selected"' : '';

					$templater = vB_Template::create('option');
						$templater->register('optionvalue', $optionvalue);
						$templater->register('optiontitle', $optiontitle);
						$templater->register('optionselected', $optionselected);
					$categoryselect .= $templater->render();

					// are there subcategories in this category?
					foreach ($catcache AS $subrow)
					{
						if ($subrow['parentid'] == $row['id'] AND $subrow['status'] > 0)
						{
							if (fetch_entertain_catpermission($subrow['id'], false))
							{
								$optionvalue =& $subrow['id'];
								$optiontitle =& $subrow['name'];
								$optionselected = ($catid == $subrow['id']) ? 'selected="selected"' : '';

								$templater = vB_Template::create('option');
									$templater->register('optionvalue', $optionvalue);
									$templater->register('optiontitle', '-- ' . $optiontitle);
									$templater->register('optionselected', $optionselected);
								$categoryselect .= $templater->render();
							}
						}
					}
				}
			}
		}
	}

	// fetch all items of defined category
	$hook_query_condition = $hook_query_joins = $hook_query_where = '';
	($hook = vBulletinHook::fetch_hook('vbentertain_query_home_all_items_of_cat')) ? eval($hook) : false;

	$itemlist = $db->query_read_slave("
		SELECT SQL_CALC_FOUND_ROWS *
		FROM " . TABLE_PREFIX . "vbentertain_item AS item
		$hook_query_joins
		WHERE categoryid = " . intval($catid) . "
		$hook_query_where
			AND status = 1
			$hook_query_condition
		ORDER BY name ASC
	");

	if ($db->num_rows($itemlist) > 0)
	{
		$templater = vB_Template::create('vbentertain_select_item_start');
		$itemselect = $templater->render();

		while ($row = $item = $db->fetch_array($itemlist))
		{
			($hook = vBulletinHook::fetch_hook('vbentertain_home_item_build')) ? eval($hook) : false;

			$optionvalue =& $row['id'];
			$optiontitle =& $row['name'];
			$optionselected = ($itemid == $row['id']) ? 'selected="selected"' : '';

			$templater = vB_Template::create('option');
				$templater->register('optionvalue', $optionvalue);
				$templater->register('optiontitle', $optiontitle);
				$templater->register('optionselected', $optionselected);
			$itemselect .= $templater->render();
		}
		$templater = vB_Template::create('vbentertain_select_complete');
		$itemselect .= $templater->render();
	}

	// did user vote yet and is user allowed to vote?
	if ($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_vote'])
	{
		$show['vote_general'] =  true;

		$hook_query_joins = $hook_query_where = $hook_query_condition = '';
		($hook = vBulletinHook::fetch_hook('vbentertain_query_check_if_voted_yet')) ? eval($hook) : false;
	
		if ($ownvote = $db->query_first("
			SELECT *
			FROM " . TABLE_PREFIX . "vbentertain_rate
			$hook_query_joins
			WHERE userid = " . $vbulletin->userinfo['userid'] . "
			$hook_query_where
				AND itemid = " . intval($itemid) . "
				$hook_query_condition
		"))
		{
			$show['vote'] =  true;
		}
		else
		{
			$show['vote'] =  false;
		}
	}
	else
	{
		$show['vote_general'] =  false;
	}

	// fetch comment and is user allowed to comment?
	if ($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_comment'])
	{
		$show['comment_general'] =  true;
		$show['comment'] = false;

		$comments = $db->query_first("
			SELECT COUNT(*) AS count, MAX(dateline) AS dateline, MAX(commentid) AS commentid
			FROM " . TABLE_PREFIX . "vbentertain_comment
			WHERE state = 'visible'
			AND itemid = '" . intval($itemid) . "'
		");

		if ($comments['commentid'])
		{
			if ($comments['count'] > 0)
			{
				if($comment = $db->query_first("
					SELECT item.*, comment.*
					FROM " . TABLE_PREFIX . "vbentertain_item AS item
					LEFT JOIN " . TABLE_PREFIX . "vbentertain_comment AS comment ON (comment.itemid = item.id)
					WHERE comment.commentid = '" . intval($comments['commentid']) . "'
				"))
				{
					$show['comment'] = true;
					$comment['date'] = vbdate($vbulletin->options['dateformat'], $comment['dateline'], $vbulletin->options['yestoday']);
					$comment['time'] = vbdate($vbulletin->options['timeformat'], $comment['dateline'], $vbulletin->options['yestoday']);
				}
			}
		}
	}
	else
	{
		$show['comment_general'] =  false;
	}

	// fetch actual item
	$hook_query_joins = $hook_query_where = '';
	($hook = vBulletinHook::fetch_hook('vbentertain_query_home_all_items_of_cat')) ? eval($hook) : false;

	$item = $db->query_first("
		SELECT *
		FROM " . TABLE_PREFIX . "vbentertain_item
		$hook_query_joins
		WHERE id = " . intval($itemid) . "
		$hook_query_where
	");

	$item['date'] = vbdate($vbulletin->options['dateformat'], $item['dateline'], $vbulletin->options['yestoday']);
	$item['time'] = vbdate($vbulletin->options['timeformat'], $item['dateline'], $vbulletin->options['yestoday']);
	$item['vote'] = $ownvote['vote'];

	if ($item['votenum'] > 0)
	{
		$item['rating'] = intval(round($item['votetotal'] / $item['votenum']));
	}
	else
	{
		$item['rating'] = '0';
	}

	$show['admin'] = ($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_admin'] ? true : false);
	$show['edit'] = ($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_change_own'] AND $item['userid'] == $vbulletin->userinfo['userid'] ? true : false);
	$show['delete'] = ($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_delete_own'] AND $item['userid'] == $vbulletin->userinfo['userid'] ? true : false);
	$show['search'] = ($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_search'] ? true : false);
	$show['add'] = ($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_add'] ? true : false);

	$templater = vB_Template::create('vbentertain_home_item');
		$templater->register('item', $item);
		$templater->register('comment', $comment);
	$itemdetails = $templater->render();

	// fetch player
	$player['height'] = $vbulletin->options['vbentertain_player_height'];
	$player['width'] = $vbulletin->options['vbentertain_player_width'];
	$player['autostart_num'] = $vbulletin->options['vbentertain_player_autostart'];
	$player['autostart_boo'] = ($vbulletin->options['vbentertain_player_autostart'] ? true : false);
	$player['url'] = ($vbulletin->options['vbentertain_player_autostart'] ? $item['streamurl'] : '');
	$show['selectplayer'] = ($vbulletin->options['vbentertain_player_userchoose'] ? true : false);

	switch ($vbulletin->options['vbentertain_playerid'])
	{
		case '0':
			$defined = '';
			$player_template = 'vbentertain_player_real_player';
			break;
		case '1':
			$defined = '';
			$player_template = 'vbentertain_player_quicktime_player';
			break;
		case '2':
			$defined = '';
			$player_template = 'vbentertain_player_media_player';
			break;
		case '3':
			if ($vbulletin->options['vbentertain_player_defined'])
			{
				$defined = $vbulletin->options['vbentertain_player_defined'];
				$player_template = 'vbentertain_player_defined';
			}
			else
			{
				$defined = '';
				$player_template = 'vbentertain_player_media_player';
			}
			break;
		default:
			$defined = '';
			$player_template = 'vbentertain_player_media_player';
			break;
	}

	$playeridselect = array();
	$playeridselect[$vbulletin->options[vbentertain_playerid]] = 'selected="selected"';

	$templater = vB_Template::create($player_template);
		$templater->register('defined', $defined);
		$templater->register('player', $player);
		$templater->register('item', $item);
		$templater->register('playerid', $vbulletin->options['vbentertain_playerid']);
	$player = $templater->render();

	// fetch latest items
	$hook_query_joins = $hook_query_where = $hook_query_condition = $new_items = '';
	($hook = vBulletinHook::fetch_hook('vbentertain_query_home_latest_items')) ? eval($hook) : false;

	$latest_items = $db->query_read_slave("
		SELECT *
		FROM " . TABLE_PREFIX . "vbentertain_item
		$hook_query_joins
		WHERE status = '1'
		$hook_query_where
		ORDER BY dateline desc
		$hook_query_condition
		LIMIT 3
	");

	while ($row = $db->fetch_array($latest_items))
	{
		$row['date'] = vbdate($vbulletin->options['dateformat'], $row['dateline'], $vbulletin->options['yestoday']);
		$row['time'] = vbdate($vbulletin->options['timeformat'], $row['dateline'], $vbulletin->options['yestoday']);

		// if there are categories
		if (count($catcache))
		{
			foreach ($catcache AS $cat)
			{
				// is this category a main category?
				if ($cat['id'] == $row['categoryid'])
				{
					$row['categoryname'] = $cat['name'];
				}
			}
		}

		$templater = vB_Template::create('vbentertain_new_items_bit');
			$templater->register('row', $row);
		$new_items .= $templater->render();
	}

	// fetch latest comments
	$hook_query_joins = $hook_query_where = $hook_query_condition = $new_comments = '';
	($hook = vBulletinHook::fetch_hook('vbentertain_query_home_latest_comments')) ? eval($hook) : false;

	$latest_comments = $db->query_read_slave("
		SELECT *
		FROM " . TABLE_PREFIX . "vbentertain_comment
		$hook_query_joins
		WHERE state = 'visible'
		$hook_query_where
		ORDER BY dateline desc
		$hook_query_condition
		LIMIT 3
	");

	while ($row = $db->fetch_array($latest_comments))
	{
		$row['date'] = vbdate($vbulletin->options['dateformat'], $row['dateline'], $vbulletin->options['yestoday']);
		$row['time'] = vbdate($vbulletin->options['timeformat'], $row['dateline'], $vbulletin->options['yestoday']);
		$row['username'] = $row['postusername'];
		$row['userid'] = $row['postuserid'];

		$templater = vB_Template::create('vbentertain_new_comments_bit');
			$templater->register('row', $row);
		$new_comments .= $templater->render();
	}

	// navbar and output
	$navbits = construct_navbits(array(
		'' => $vbphrase['vbentertain_navbit_headline']
	));

	$navbar = render_navbar_template($navbits);

	($hook = vBulletinHook::fetch_hook('vbentertain_home_complete')) ? eval($hook) : false;

	$templater = vB_Template::create('vbentertain_home');
		$templater->register_page_templates();
		$templater->register('navbar', $navbar);
		$templater->register('categoryselect', $categoryselect);
		$templater->register('itemselect', $itemselect);
		$templater->register('itemdetails', $itemdetails);
		$templater->register('new_items', $new_items);
		$templater->register('new_comments', $new_comments);
		$templater->register('player', $player);
		$templater->register('playeridselect', $playeridselect);
		$templater->register('vote', $player);
		$templater->register('contenttypeid', $contenttypeid);
	print_output($templater->render());
}

// #######################################################################
if ($_REQUEST['do'] == 'ajaxcategory')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'catid' => TYPE_INT
	));

	($hook = vBulletinHook::fetch_hook('vbentertain_ajax_category_start')) ? eval($hook) : false;

	$itemselect = $vbphrase['vbentertain_home_no_items_yet'];

	if ($vbulletin->GPC['catid'])
	{
		$hook_query_joins = $hook_query_where = '';
		($hook = vBulletinHook::fetch_hook('vbentertain_query_ajax_category')) ? eval($hook) : false;

 		$category = $db->query_read("
			SELECT * 
			FROM " . TABLE_PREFIX . "vbentertain_item
			$hook_query_joins
			WHERE categoryid = " . intval($vbulletin->GPC['catid']) . "
			$hook_query_where
			ORDER BY name ASC
		");

		if ($db->num_rows($category) > 0)
		{
			$templater = vB_Template::create('vbentertain_select_item_start');
			$itemselect = $templater->render();

			while ($row = $db->fetch_array($category))
			{
				$optionvalue =& $row['id'];
				$optiontitle =& $row['name'];
				$optionselected = '';

				$templater = vB_Template::create('option');
					$templater->register('optionvalue', $optionvalue);
					$templater->register('optiontitle', $optiontitle);
					$templater->register('optionselected', $optionselected);
				$itemselect .= $templater->render();
			}
			$templater = vB_Template::create('vbentertain_select_complete');
			$itemselect .= $templater->render();
		}
		else
		{
			$itemdetails = $vbphrase['vbentertain_home_no_items_yet'];
		}
	}

	($hook = vBulletinHook::fetch_hook('vbentertain_ajax_category_complete')) ? eval($hook) : false;

	echo $itemselect;
}

// #######################################################################
if ($_REQUEST['do'] == 'ajaxitem')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'id' => TYPE_INT
	));

	($hook = vBulletinHook::fetch_hook('vbentertain_ajax_item_start')) ? eval($hook) : false;

	$itemdetails = $vbphrase['vbentertain_home_no_item_details'];

	if ($vbulletin->GPC['id'])
	{
		$hook_query_joins = $hook_query_where = '';
		($hook = vBulletinHook::fetch_hook('vbentertain_query_ajax_item')) ? eval($hook) : false;

 		$item = $db->query_first("
			SELECT * 
			FROM " . TABLE_PREFIX . "vbentertain_item
			$hook_query_joins
			WHERE id = " . intval($vbulletin->GPC['id']) . "
			$hook_query_where
		");

		if ($item)
		{
			// did user vote yet and he is allowed to vote?
			if ($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_vote'])
			{
				$show['vote_general'] =  true;
				$hook_query_joins = $hook_query_where = $hook_query_condition = '';
				($hook = vBulletinHook::fetch_hook('vbentertain_query_check_if_voted_yet')) ? eval($hook) : false;

				if ($ownvote = $db->query_first("
					SELECT *
					FROM " . TABLE_PREFIX . "vbentertain_rate
					$hook_query_joins
					WHERE userid = " . $vbulletin->userinfo['userid'] . "
					$hook_query_where
						AND itemid = " . intval($vbulletin->GPC['id']) . "
						$hook_query_condition
				"))
				{
					$show['vote'] =  true;
				}
				else
				{
					$show['vote'] =  false;
				}

				$item['vote'] = $ownvote['vote'];

				$item['date'] = vbdate($vbulletin->options['dateformat'], $item['dateline'], $vbulletin->options['yestoday']);
				$item['time'] = vbdate($vbulletin->options['timeformat'], $item['dateline'], $vbulletin->options['yestoday']);
				$item['vote'] = $ownvote['vote'];

				if ($item['votenum'] > 0)
				{
					$item['rating'] = intval(round($item['votetotal'] / $item['votenum']));
				}
				else
				{
					$item['rating'] = '0';
				}
			}
			else
			{
				$show['vote_general'] =  false;
			}

			// fetch comment and is user allowed to comment?
			if ($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_comment'])
			{
				$show['comment_general'] =  true;
				$show['comment'] = false;

				$comments = $db->query_first("
					SELECT COUNT(*) AS count, MAX(dateline) AS dateline, MAX(commentid) AS commentid
					FROM " . TABLE_PREFIX . "vbentertain_comment
					WHERE state = 'visible'
					AND itemid = '" . intval($vbulletin->GPC['id']) . "'
				");

				if ($comments['commentid'])
				{
					if ($comments['count'] > 0)
					{
						if($comment = $db->query_first("
							SELECT item.*, comment.*
							FROM " . TABLE_PREFIX . "vbentertain_item AS item
							LEFT JOIN " . TABLE_PREFIX . "vbentertain_comment AS comment ON (comment.itemid = item.id)
							WHERE comment.commentid = '" . intval($comments['commentid']) . "'
						"))
						{
							$show['comment'] = true;
							$comment['date'] = vbdate($vbulletin->options['dateformat'], $comment['dateline'], $vbulletin->options['yestoday']);
							$comment['time'] = vbdate($vbulletin->options['timeformat'], $comment['dateline'], $vbulletin->options['yestoday']);
						}
					}
				}
			}
			else
			{
				$show['comment_general'] =  false;
			}

			$show['admin'] = ($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_admin'] ? true : false);
			$show['edit'] = ($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_change_own'] AND $item['userid'] == $vbulletin->userinfo['userid'] ? true : false);
			$show['delete'] = ($permissions['vbentertain_general_permissions'] & $vbulletin->bf_ugp['vbentertain_general_permissions']['can_delete_own'] AND $item['userid'] == $vbulletin->userinfo['userid'] ? true : false);

			$templater = vB_Template::create('vbentertain_home_item');
				$templater->register('item', $item);
				$templater->register('comment', $comment);
			$itemdetails = $templater->render();
		}
		else
		{
			$itemdetails = $vbphrase['vbentertain_home_no_item_details'];
		}
	}

	($hook = vBulletinHook::fetch_hook('vbentertain_ajax_item_complete')) ? eval($hook) : false;

	echo $itemdetails;
}

// #######################################################################
if ($_REQUEST['do'] == 'ajaxplay')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'id'		=> TYPE_INT,
		'playerid'	=> TYPE_INT
	));

	($hook = vBulletinHook::fetch_hook('vbentertain_ajax_play_start')) ? eval($hook) : false;

	$itemdetails = $vbphrase['vbentertain_home_no_item_details'];

	if ($vbulletin->GPC['id'])
	{
		$hook_query_joins = $hook_query_where = '';
		($hook = vBulletinHook::fetch_hook('vbentertain_query_ajax_item')) ? eval($hook) : false;

 		$item = $db->query_first("
			SELECT * 
			FROM " . TABLE_PREFIX . "vbentertain_item
			$hook_query_joins
			WHERE id = " . intval($vbulletin->GPC['id']) . "
			$hook_query_where
		");

		if ($item)
		{
			// fetch player
			$player['height'] = $vbulletin->options['vbentertain_player_height'];
			$player['width'] = $vbulletin->options['vbentertain_player_width'];
			$player['url'] = $item['streamurl'];

if ($vbulletin->GPC['playerid'])
{
			switch ($vbulletin->GPC['playerid'])
			{
				case '0':
					$defined = '';
					$player_template = 'vbentertain_player_real_player';
					break;
				case '1':
					$defined = '';
					$player_template = 'vbentertain_player_quicktime_player';
					break;
				case '2':
					$defined = '';
					$player_template = 'vbentertain_player_media_player';
					break;
				case '3':
					if ($vbulletin->options['vbentertain_player_defined'])
					{
						$defined = $vbulletin->options['vbentertain_player_defined'];
						$player_template = 'vbentertain_player_defined';
					}
					else
					{
						$defined = '';
						$player_template = 'vbentertain_player_media_player';
					}
					break;
				default:
					$defined = '';
					$player_template = 'vbentertain_player_media_player';
					break;
			}
}
else
{
			switch ($vbulletin->options['vbentertain_playerid'])
			{
				case '0':
					$defined = '';
					$player_template = 'vbentertain_player_real_player';
					break;
				case '1':
					$defined = '';
					$player_template = 'vbentertain_player_quicktime_player';
					break;
				case '2':
					$defined = '';
					$player_template = 'vbentertain_player_media_player';
					break;
				case '3':
					if ($vbulletin->options['vbentertain_player_defined'])
					{
						$defined = $vbulletin->options['vbentertain_player_defined'];
						$player_template = 'vbentertain_player_defined';
					}
					else
					{
						$defined = '';
						$player_template = 'vbentertain_player_media_player';
					}
					break;
				default:
					$defined = '';
					$player_template = 'vbentertain_player_media_player';
					break;
			}
}
			$templater = vB_Template::create($player_template);
				$templater->register('item', $item);
				$templater->register('player', $player);
				$templater->register('playerid', $vbulletin->options['vbentertain_playerid']);
			$itemdetails = $templater->render();
		}
		else
		{
			$itemdetails = $vbphrase['vbentertain_home_no_item_details'];
		}
	}

	($hook = vBulletinHook::fetch_hook('vbentertain_ajax_play_complete')) ? eval($hook) : false;

	echo $itemdetails;
}

// #######################################################################
if ($_REQUEST['do'] == 'ajaxvote')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'id' => TYPE_INT,
		'vote' => TYPE_INT
	));

	($hook = vBulletinHook::fetch_hook('vbentertain_ajax_vote_start')) ? eval($hook) : false;

	$itemdetails = $vbphrase['vbentertain_home_no_item_details'];

	if ($vbulletin->GPC['id'] AND $vbulletin->GPC['id'])
	{
		$hook_query_joins = $hook_query_where = '';
		($hook = vBulletinHook::fetch_hook('vbentertain_query_voted_yet')) ? eval($hook) : false;

		if ($ownvote = $db->query_first("
			SELECT *
			FROM " . TABLE_PREFIX . "vbentertain_rate
			$hook_query_joins
			WHERE userid = " . $vbulletin->userinfo['userid'] . "
			$hook_query_where
				AND itemid = " . intval($vbulletin->GPC['id']) . "
		"))
		{
			$itemdetails = $vbphrase['vbentertain_home_vote_error'];
		}
		else
		{
			$db->query_write("
				UPDATE " . TABLE_PREFIX . "vbentertain_item
				SET votenum = votenum + 1, votetotal = votetotal + " . intval($vbulletin->GPC['vote']) . "
				WHERE id = " . intval($vbulletin->GPC['id']) . "
			");

			$db->query_write("INSERT INTO " . TABLE_PREFIX . "vbentertain_rate (itemid, userid, vote, ipaddress)
			VALUES (
				'" . intval($vbulletin->GPC['id']) . "',
				'" . intval($vbulletin->userinfo['userid']) . "',
				'" . intval($vbulletin->GPC['vote']) . "',
				'" . $db->escape_string(IPADDRESS) . "'
			)");
		}

		$templater = vB_Template::create('vbentertain_home_own_vote');
			$templater->register('vote', $vbulletin->GPC['vote']);
		$itemdetails = $templater->render();
	}
	else
	{
		$itemdetails = $vbphrase['vbentertain_home_vote_error'];
	}

	($hook = vBulletinHook::fetch_hook('vbentertain_ajax_vote_complete')) ? eval($hook) : false;

	echo $itemdetails;
}

// #######################################################################
?>
